import { useState, useEffect } from 'react';

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
    return;
  }

  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

function useTransitionTimeout(milliseconds) {
  var trigger = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

  // Track timeout done state
  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      done = _useState2[0],
      setDone = _useState2[1]; // Track the timeout pointer used in in case we need to unmount before timeout is complete


  var _useState3 = useState(),
      _useState4 = _slicedToArray(_useState3, 2),
      arbitraryTimeout = _useState4[0],
      setArbitraryTimeout = _useState4[1]; // Do this on load;
  // Observe the optional trigger to reset done state


  useEffect(function () {
    unload();
    init();
    return function () {
      return unload();
    };
  }, [trigger]);
  useEffect(function () {
    return function () {
      return unload();
    };
  }, []); // Provide method for unmounting

  function unload() {
    setArbitraryTimeout(clearTimeout(arbitraryTimeout));
  } // The init method used by mounting components


  function init() {
    // Reset the done status
    setDone(false); // Run a timeout in passed milliseconds
    // Track the timeout with doneTimeout state

    setArbitraryTimeout(setTimeout(function () {
      // Let the component know we are done.
      setDone(true); // Clean up

      unload();
    }, milliseconds));
  }

  return [done, init, unload];
}

export default useTransitionTimeout;
//# sourceMappingURL=index.es.js.map
